; 
;                                Build this dialog with MAKEIT.BAT
; 

    include \masm32\include\masm32rt.inc
    .686p
    .MMX
    .XMM

; 

    include tributn.inc

    tributton PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    tributnProc PROTO :DWORD,:DWORD,:DWORD,:DWORD


  ; --------------------
  ; GLOBAL scope handles
  ; --------------------
    .data?
      hInstance  dd ?
      hWnd       dd ?
      hGroup     dd ?
      hButn1     dd ?
      hButn2     dd ?

    .code

start:
    mov hInstance, FUNC(GetModuleHandle, NULL)

  ; -------------------------------------------
  ; Call the dialog box from the resource file
  ; -------------------------------------------
    invoke DialogBoxParam,hInstance,100,0,ADDR DlgProc,0

    invoke ExitProcess,eax

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL icce:INITCOMMONCONTROLSEX
    LOCAL btnrv :DWORD

    STRING dlgTitle, " Test Tri Button Dialog"

      switch uMsg
        case WM_INITDIALOG
          m2m hWnd, hWin    ; Copy hWin to GLOBAL variable
          invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle
          invoke SendMessage,hWin,WM_SETICON,1,FUNC(LoadIcon,hInstance,500)

          mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
          xor eax, eax                                            ; set EAX to zero
          or eax, ICC_WIN95_CLASSES
 ;           or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
 ;           or eax, ICC_COOL_CLASSES
 ;           or eax, ICC_DATE_CLASSES
 ;           or eax, ICC_HOTKEY_CLASS
 ;           or eax, ICC_INTERNET_CLASSES
 ;           or eax, ICC_LISTVIEW_CLASSES
 ;           or eax, ICC_PAGESCROLLER_CLASS
 ;           or eax, ICC_PROGRESS_CLASS
 ;           or eax, ICC_TAB_CLASSES
 ;           or eax, ICC_TREEVIEW_CLASSES
 ;           or eax, ICC_UPDOWN_CLASS
 ;           or eax, ICC_USEREX_CLASSES

  ; --------------------------------------------
  ; NOTE : It is marginally more efficient to OR
  ; required styles together at assembly time.
  ; --------------------------------------------

          mov icce.dwICC, eax
          invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library

        ; --------------------------------
        ; Get the handle for each control
        ; --------------------------------
          mov hGroup, rv(GetDlgItem,hWin,101)
          mov hButn1, rv(GetDlgItem,hWin,102)
          mov hButn2, rv(GetDlgItem,hWin,103)

          xor eax, eax
          ret

      case WM_COMMAND
        switch wParam
          case 102

          .data
            usermessage \
              db "    I met a traveller from an antique land",13,10
              db "    Who said: Two vast and trunkless legs of stone",13,10
              db "    Stand in the desert. Near them on the sand,",13,10
              db "    Half sunk, a shatter",39,"d visage lies, whose frown",13,10
              db "    And wrinkled lip and sneer of cold command",13,10
              db "    Tell that its sculptor well those passions read",13,10
              db "    Which yet survive, stamp",39,"d on these lifeless things,",13,10
              db "    The hand that mock",39,"d them and the heart that fed.",13,10
              db "    And on the pedestal these words appear:",13,10
              db "    ",34,"My name is Ozymandias, king of kings:",13,10
              db "    Look on my works, ye mighty, and despair!",34,13,10
              db "    Nothing beside remains: round the decay",13,10
              db "    Of that colossal wreck, boundless and bare,",13,10
              db "    The lone and level sands stretch far away.",13,10
              db 13,10
              db "    Percy Bysshe Shelley (1792-1822)",13,10,0

          .code

          ; -------------------------------
          ; call the memory template dialog
          ; -------------------------------
            mov btnrv, rv(tributton,hWnd,"Impressed","Indifferent","Who cares",ADDR usermessage,"Ozymandias",550)

            switch btnrv
              case 0
                fn MsgboxI,hWin,"Chicken, you cancelled.    ","Chicken",MB_OK,500
              case 1
                fn MsgboxI,hWin,"Is your taste THAT bad ?    ","Dimwit",MB_OK,500
              case 2
                fn MsgboxI,hWin,"You think you can do better ?    ","Smartarse",MB_OK,500
              case 3
                fn MsgboxI,hWin,"So you are as dumb as you look.    ","Dumb Phuk",MB_OK,500
            endsw

          case 103
            jmp exit_dialog
        endsw

      case WM_CLOSE
        exit_dialog:                ; jump to this label to close program
        invoke EndDialog,hWin,0

      endsw

    xor eax, eax    ; this must be here in NT4 and later
    ret

DlgProc endp

; 

MsgboxI proc hParent:DWORD,pText:DWORD,pTitle:DWORD,mbStyle:DWORD,IconID:DWORD

    LOCAL mbp   :MSGBOXPARAMS

    or mbStyle, MB_USERICON

    mov mbp.cbSize,             SIZEOF mbp
    m2m mbp.hwndOwner,          hParent
    mov mbp.hInstance,          rv(GetModuleHandle,0)
    m2m mbp.lpszText,           pText
    m2m mbp.lpszCaption,        pTitle
    m2m mbp.dwStyle,            mbStyle
    m2m mbp.lpszIcon,           IconID
    mov mbp.dwContextHelpId,    NULL
    mov mbp.lpfnMsgBoxCallback, NULL
    mov mbp.dwLanguageId,       NULL

    invoke MessageBoxIndirect,ADDR mbp

    ret

MsgboxI endp

; 

tributton proc hParent:DWORD,btxt1:DWORD,btxt2:DWORD,btxt3:DWORD,msgtxt:DWORD,caption:DWORD,bmpID:DWORD

    LOCAL arr[8]:DWORD

  ; ----------------------------------------------------
  ; load the array with the atributes for the dialog box
  ; ----------------------------------------------------
    lea edx, arr
    m2m [edx], btxt1
    m2m [edx+4], btxt2
    m2m [edx+8], btxt3
    m2m [edx+12], msgtxt
    m2m [edx+16], caption
    m2m [edx+20], bmpID

    Dialog " ",\                        ; dialog title
    "MS Sans Serif",8,\                 ; font name & point size
    WS_OVERLAPPED or WS_SYSMENU or DS_CENTER,\ ; window style
    5,\                                 ; control count
    50,50,\                             ; top X Y coordinates
    300,110,\                           ; width and height
    1024                                ; buffer size to allocate

    DlgButton " ",BS_PUSHBUTTON,30,70,70,14,1000
    DlgButton " ",BS_PUSHBUTTON,115,70,70,14,1001
    DlgButton " ",BS_PUSHBUTTON,200,70,70,14,1002
    DlgBitmapEx   0,5,5,45,45,1003

    DlgEdit       ES_LEFT or ES_MULTILINE or WS_VSCROLL or ES_READONLY,55,10,238,56,1004

    CallModalDialog hInstance,\         ; the Instance handle
                    hParent,\           ; the parent handle
                    tributnProc,\       ; name of dialog proc
                    ADDR arr            ; pass the array address

  ; --------------------------------------
  ; the return value set by the user is
  ; in EAX from the previous function call
  ; --------------------------------------

    ret

tributton endp

; 

tributnProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hBitmap   :DWORD

      switch uMsg
        case WM_INITDIALOG
          push esi
          mov esi, lParam               ; load the array address into ESI

          fn SetWindowText,rv(GetDlgItem,hWin,1000),[esi]       ; the 3 button texts
          fn SetWindowText,rv(GetDlgItem,hWin,1001),[esi+4]
          fn SetWindowText,rv(GetDlgItem,hWin,1002),[esi+8]
          fn SetWindowText,rv(GetDlgItem,hWin,1004),[esi+12]    ; the message text
          fn SetWindowText,hWin,[esi+16]                        ; the title bar caption

          invoke LoadImage,hInstance,[esi+20],IMAGE_BITMAP, \   ; load the resource bitmap
                 0,0,LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS
          mov hBitmap, eax

          fn SendMessage,rv(GetDlgItem,hWin,1003),STM_SETIMAGE,IMAGE_BITMAP,hBitmap

          pop esi

        case WM_COMMAND
          switch wParam
            case 1000
              invoke EndDialog,hWin,1   ; return 1 for button 1
            case 1001
              invoke EndDialog,hWin,2   ; return 2 for button 2
            case 1002
              invoke EndDialog,hWin,3   ; return 3 for button 3
          endsw

        case WM_CLOSE
          invoke EndDialog,hWin,0       ; return 0 if canceled by system button

      endsw

    xor eax, eax
    ret

tributnProc endp

; 



end start

